<?php
define('TWITTER_URL_DEFAULT', 'http://twitter.com/home?status=');
define('TWITTER_URL_MOBILE', 'http://twtr.jp/status/create/?text=');

class NP_TwitterButton extends NucleusPlugin {

	function getName() {
		return 'TwitterButton';
	}

	function getAuthor() {
		return 'mksmk';
	}

	function getURL() {
		return 'http://www.mksmk.jp/';
	}

	function getVersion() {
		return '0.1.3b';
	}

	function getDescription() {
		return 'output TwitterButton.';
	}

	function supportsFeature($what) {
		switch ($what) {
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}

	function getEventList() {
		return array('PreItem');
	}

	function install() {
		$this->createOption ('tw_charset', "charset setting.", 'select', 'euc-jp', 'euc-jp|EUC-JP|utf-8|UTF-8');
		$this->createOption ('tw_B_color', "TwitterButtonColor select.", 'select', 'twitter_button_b.gif',
			'blue|twitter_button_b.gif|'.
			'green|twitter_button_g.gif|'.
			'orange|twitter_button_o.gif|'.
			'purple|twitter_button_p.gif|'.
			'red|twitter_button_r.gif|'.
			'water blue|twitter_button_wb.gif|'.
			'yellow|twitter_button_y.gif');
		$this->createOption ('tw_title_header_mess', "want to tag line?", 'text', '', '');
		$this->createOption ('tw_title_separator1', "determine the connection symbol(title to blogs).", 'text', '@', '@');
		$this->createOption ('tw_title_separator2', "determine the connection symbol(blogs to url)", 'text', ':', ':');
		$this->createOption ('twB_AltAndTitle', "set alt and title mess TwitterButton.", 'text', 'tweet!!:', 'tweet!!');
	}

	function event_PreItem($data) {
		$this->currentItem = &$data["item"];
		$this->index_item_title = $this->currentItem->title;
		$this->index_itemid = $this->currentItem->itemid;
	}

	function doTemplateVar(&$item) {
		global $CONF, $manager, $blogid, $itemid;

		$MobPHP = false;
		if ($manager->pluginInstalled('NP_MobileWithSinglePage') || $manager->pluginInstalled('NP_AdjustSkin2Mobile')) {
			//load library(@PEAR)
			require_once(dirname(__FILE__).'/sharedlibs/sharedlibs.php');
			$MobPHP = true;
		}

		$tw_charset = $this->getOption('tw_charset');
		$tw_title_header_mess = $this->getOption('tw_title_header_mess');
		$tw_title_separator1 = $this->getOption('tw_title_separator1');
		$tw_title_separator2 = $this->getOption('tw_title_separator2');
		$tw_button = $CONF['MediaURL'] . "TwitterB/" . $this->getOption('tw_B_color');
		$twB_AltAndTitle = $this->getOption('twB_AltAndTitle');

//		$item =& $manager->getItem($itemid, 0, 0);
		$blog =& $manager->getBlog($blogid, 0, 0);

		$tw_item_title = $item['title'];

//		if (!$tw_item_title) {
			$tw_item_title = $this->index_item_title;
//		} 
//		if (!$itemid) {
			$itemid = $this->index_itemid;
//		}

		$tw_item_url = createItemLink($itemid, $this->linkparams);
		$tw_blog_name = $blog->getName();

		if ($tw_title_header_mess) {
			$tw_data_set = $tw_title_header_mess . " " . $tw_item_title . $tw_title_separator1 . $tw_blog_name . $tw_title_separator2 . $tw_item_url;
		} else {
			$tw_data_set = $tw_item_title . $tw_title_separator1 . $tw_blog_name . $tw_title_separator2 . $tw_item_url;
		}

		if ($MobPHP == true) {
			require_once('Net/UserAgent/Mobile.php');
//			$getUAName = Net_UserAgent_Mobile::factory();
			$getUAName = Net_UserAgent_Mobile::singleton();
//			$UserAgent = $getUAName['carrierShortName'];
			$UserAgent = $getUAName->getName();
		} elseif ($MobPHP == false) {
			$UserAgent = $_SERVER["HTTP_USER_AGENT"];
//			$UserAgent = serverVar('HTTP_USER_AGENT');
		}
		switch(true){
			case(ereg("UP.Browser|KDDI", $UserAgent)):
			$CheckUA['mob'] = '1';
			$CheckUA['tw_url'] = TWITTER_URL_MOBILE;
		break;
			case(ereg("DoCoMo|J-PHONE|Vodafone|MOT-|SoftBank", $UserAgent)):
			$CheckUA['mob'] = '2';
			$CheckUA['tw_url'] = TWITTER_URL_MOBILE;
		break;
			default:
			$CheckUA['mob'] = '0';
			$CheckUA['tw_url'] = TWITTER_URL_DEFAULT;
		break;
		}

		if ($CheckUA['mob'] == "1") {
			$tw_enco = mb_convert_encoding($tw_data_set, "CP932", "$tw_charset");
		} elseif ($CheckUA['mob'] == "2") {
			$tw_enco = mb_convert_encoding($tw_data_set, "UTF-8", "$tw_charset");
		} else {
			$tw_enco = mb_convert_encoding($tw_data_set, "UTF-8", "$tw_charset");
		}
		$tw_data = urlencode(htmlspecialchars($tw_enco, ENT_QUOTES));

		$twitter_button = '<a href="' . $CheckUA['tw_url'] . $tw_data . '" target="_blank"><img src="' . $tw_button . '" alt="' . $twB_AltAndTitle . '" title="' . $twB_AltAndTitle . '"/></a>';
		echo $twitter_button;

	}
}
?>
